#include "xyz.hh"
#include "matrix.hh"

void XYZ::Rotate(const Matrix &m)
{
    m.Rotate(*this);
}

const XYZ XYZ::RotatedBy(const Matrix &m) const
{
    XYZ tmp = *this;
    m.Rotate(tmp);
    return tmp;
}

void XYZ::RotateAround(const XYZ &axis, FLOAT_ARG angle)
{
    Matrix(axis, angle).Rotate(*this);
}

const XYZ XYZ::RotatedAround(const XYZ &axis, FLOAT_ARG angle) const
{
    return RotatedBy(Matrix(axis, angle));
}

const FLOAT XYZ::dist(const XYZ &p) const
{
    XYZ d(x-p.x, y-p.y, z-p.z);
    return d.size();
}

const XYZ XYZ::MirroredAround(const XYZ &axis) const
{
    // This could be replaced with RotatedAround(axis, DEG2RAD(180)),
    // but as SIN(180)=0 and COS(180)=-1, this is simplified a lot.
    // Terribly lot. :)
    XYZ N(axis);
    N.Normalize();
    return N * (DotProduct(N) * 2.0) - *this;
}

void XYZ::MirrorAround(const XYZ &axis)
{
    *this = MirroredAround(axis);
}

XYZ avg(const XYZ &a, const XYZ &b)
{
    return XYZ((a.x + b.x)/2, (a.y + b.y)/2, (a.z + b.z)/2);
}
